• 【34.57%】【codeforces 557D】Vitaly and Cycle


    time limit per test1 second
    memory limit per test256 megabytes
    inputstandard input
    outputstandard output
    After Vitaly was expelled from the university, he became interested in the graph theory.

    Vitaly especially liked the cycles of an odd length in which each vertex occurs at most once.

    Vitaly was wondering how to solve the following problem. You are given an undirected graph consisting of n vertices and m edges, not necessarily connected, without parallel edges and loops. You need to find t — the minimum number of edges that must be added to the given graph in order to form a simple cycle of an odd length, consisting of more than one vertex. Moreover, he must find w — the number of ways to add t edges in order to form a cycle of an odd length (consisting of more than one vertex). It is prohibited to add loops or parallel edges.

    Two ways to add edges to the graph are considered equal if they have the same sets of added edges.

    Since Vitaly does not study at the university, he asked you to help him with this task.

    Input
    The first line of the input contains two integers n and m ( — the number of vertices in the graph and the number of edges in the graph.

    Next m lines contain the descriptions of the edges of the graph, one edge per line. Each edge is given by a pair of integers ai, bi (1 ≤ ai, bi ≤ n) — the vertices that are connected by the i-th edge. All numbers in the lines are separated by a single space.

    It is guaranteed that the given graph doesn’t contain any loops and parallel edges. The graph isn’t necessarily connected.

    Output
    Print in the first line of the output two space-separated integers t and w — the minimum number of edges that should be added to the graph to form a simple cycle of an odd length consisting of more than one vertex where each vertex occurs at most once, and the number of ways to do this.

    Examples
    input
    4 4
    1 2
    1 3
    4 2
    4 3
    output
    1 2
    input
    3 3
    1 2
    2 3
    3 1
    output
    0 1
    input
    3 0
    output
    3 1
    Note
    The simple cycle is a cycle that doesn’t contain any vertex twice.

    【题目链接】:http://codeforces.com/contest/557/problem/D

    【题解】

    要存在一个奇数环。
    则最多就添加3条边(3条边一定能构成一个环!)。
    1.看看整张图变成了几个连通块,如果每个连通块里面的点的个数都为1,则添加边数为3,方案数为C(n,3)=n*(n-1)*(n-2)/6,这个时候对应的情况是边数m=0;->”3 C(N,3)”
    2.每个连通块里面的点的个数的最大值为2;则连通块里面点的个数为2的情况就对应这个连通块里面只有一条边,而一条边由两个点构成,这条边上的两个点分别与其余n-2个点构成n-2个环(都是3个点的环),边的个数m就对应了连通块里面点的个数为2的情况,则方案为m*(n-2);->”2 m*(n-2)”
    下面这种情况不是奇环(而是偶环),所以”2对2的情况可以排除”;
    这里写图片描述
    3.除了以上两种情况外;
    如果在某个连通块里面不能进行二分图染色->则存在奇环。直接输出”0 1”;
    这里写图片描述
    ( 有奇环就不能完成二分图染色);
    如果都能进行二分图染色;
    则记录每个连通块里面白点(0)和黑点(1)的个数;
    设为cnt[0]和cnt[1];
    则每有一个联通块;
    答案递增C(cnt[0],2)+C(cnt[1],2);
    这里写图片描述
    可以看到每两个0之间连一条边都能构成一个奇数环;
    很有趣的性质.

    【完整代码】

    #include <bits/stdc++.h>
    using namespace std;
    #define lson l,m,rt<<1
    #define rson m+1,r,rt<<1|1
    #define LL long long
    #define rep1(i,a,b) for (int i = a;i <= b;i++)
    #define rep2(i,a,b) for (int i = a;i >= b;i--)
    #define mp make_pair
    #define pb push_back
    #define fi first
    #define se second
    #define rei(x) scanf("%d",&x)
    #define rel(x) scanf("%I64d",&x)
    #define pri(x) printf("%d",x)
    #define prl(x) printf("%I64d",x)
    
    typedef pair<int,int> pii;
    typedef pair<LL,LL> pll;
    
    const int MAXN = 1e5+10;
    const int dx[9] = {0,1,-1,0,0,-1,-1,1,1};
    const int dy[9] = {0,0,0,-1,1,-1,1,-1,1};
    const double pi = acos(-1.0);
    
    int n,m;
    int f[MAXN],num[MAXN],cnt[2];
    int color[MAXN];
    vector <int> g[MAXN];
    queue <int> dl;
    
    int ff(int x)
    {
        if (f[x]==x) return x;
        else
            f[x] = ff(f[x]);
        return f[x];
    }
    
    int main()
    {
        //freopen("F:\rush.txt","r",stdin);
        memset(color,255,sizeof color);
        rei(n);rei(m);
        rep1(i,1,n)
            f[i] = i,num[i] = 1;
        rep1(i,1,m)
        {
            int x,y;
            rei(x);rei(y);
            g[x].pb(y);
            g[y].pb(x);
            int r1 = ff(x),r2 = ff(y);
            if (r1!=r2)
            {
                f[r1]=r2;
                num[r2]+=num[r1];
            }
        }
        int ma = 1;
        LL ans = 0;
        rep1(i,1,n)
        {
            int r = ff(i);
            ma = max(ma,num[r]);
        }
        if (ma == 1)
        {
            printf("3 %I64d
    ",1LL*n*(n-1)*(n-2)/6);
            return 0;
        }
        else
            if (ma==2)
            {
                printf("2 %I64d
    ",1LL*(n-2)*m);
                return 0;
            }
            else
            {
                rep1(i,1,n)
                    if (color[i]==-1)
                    {
                        memset(cnt,0,sizeof cnt);
                        color[i] = 0;
                        cnt[0] = 1;
                        dl.push(i);
                        bool ok = true;
                        while (!dl.empty())
                        {
                            int x = dl.front();
                            dl.pop();
                            int len = g[x].size();
                            rep1(j,0,len-1)
                            {
                                int y = g[x][j];
                                if (y==x) continue;
                                if (color[y]==-1)
                                {
                                    color[y] = 1-color[x];
                                    cnt[color[y]]++;
                                    dl.push(y);
                                }
                                else
                                    if (color[y]==color[x])
                                    {
                                        ok = false;
                                        break;
                                    }
                            }
                            if (!ok) break;
                        }
                        if (!ok)
                        {
                            printf("0 1
    ");
                            return 0;
                        }
                        if (cnt[0]>=2)
                            ans+=1LL*cnt[0]*(cnt[0]-1)/2;
                        if (cnt[1]>=2)
                            ans+=1LL*cnt[1]*(cnt[1]-1)/2;
                    }
            }
        cout <<"1 "<< ans << endl;
        return 0;
    }
  • 相关阅读:
    立个铁矿石的flag,从7月初开始,铁矿石的库存,可能要进入累库存阶段了.
    让你的 vs code 跑在云上,用手机浏览器就能写代码
    ASP.NET Core 2 High Performance 目录和读书笔记
    [转帖]无网络离线安装 vs2017
    centos下 .net core 2.0 升级 到 2.1 遇到的一个小问题
    .net core jwt 入门记录
    GTX 750TI 使用 ffmpeg 时无法用 GPU HEVC(h.265) 进行加速
    [翻译] 编写高性能 .NET 代码--第二章 GC -- 减少大对象堆的碎片,在某些情况下强制执行完整GC,按需压缩大对象堆,在GC前收到消息通知,使用弱引用缓存对象
    [翻译] 编写高性能 .NET 代码--第二章 GC -- 将长生命周期对象和大对象池化
    [翻译] 编写高性能 .NET 代码--第二章 GC -- 避免使用终结器,避免大对象,避免复制缓冲区
  • 原文地址:https://www.cnblogs.com/AWCXV/p/7626839.html
Copyright © 2020-2023  润新知